//team 28
#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <vector>
#include <queue>
#include <algorithm>
#include <sstream>
using namespace std;
ifstream in ("j.in");
FILE * fin = fopen ("j.in", "r");
typedef long long lld;
#define cin in

void pCard (int suit, int rank) {
  cout << ' ';
  if (rank == 1)
    cout << 'A';
  else if (rank == 11)
    cout << 'J';
  else if (rank == 12)
    cout << 'Q';
  else if (rank == 13)
    cout << 'K';
  else
    cout << rank;
  if (suit == 0)
    cout << 'C';
  else if (suit == 1)
    cout << 'D';
  else if (suit == 2)
    cout << 'H';
  else if (suit == 3)
    cout << 'S';
}

int main () {
  int num;
  int card[5][2];
  char str[5];

  cin >> num;

  for (int x = 1; x <= num; x ++) {
    for (int i = 0; i < 5; i ++) {
      cin >> str;
      int suit = 1;

      if (str[2] != 0) {
	suit = 2;
	card[i][1] = 10;
      } else if (str[0] == 'A')
	card[i][1] = 1;
      else if (str[0] == 'J')
	card[i][1] = 11;
      else if (str[0] == 'Q')
	card[i][1] = 12;
      else if (str[0] == 'K')
	card[i][1] = 13;
      else
	card[i][1] = str[0] - '0';

      if (str[suit] == 'C')
	card[i][0] = 0;
      else if (str[suit] == 'D')
	card[i][0] = 1;
      else if (str[suit] == 'H')
	card[i][0] = 2;
      else if (str[suit] == 'S')
	card[i][0] = 3;
    }

    int fir, sec, diff;
    bool found = false;

    for (int i = 0; i < 5; i ++) {
      for (int j = i + 1; j < 5 && !found; j ++) {
	if (card[i][0] == card[j][0]) {
	  if ((card[j][1] - card[i][1] + 13) % 13 <= 6) {
	    fir = j;
	    sec = i;
	    diff = (card[j][1] - card[i][1] + 13) % 13;
	  } else {
	    fir = i;
	    sec = j;
	    diff = (card[i][1] - card[j][1] + 13) % 13;
	  }

	  found = true;
	}
      }
    }

    for (int i = 0; i < 5; i ++) {
      if (i == fir || i == sec)
	continue;
      for (int j = i + 1; j < 5; j ++) {
	if (j == fir || j == sec)
	  continue;
	if (card[i][1] > card[j][1] || card[i][1] == card[j][1] && card[i][0] > card[j][0]) {
	  swap (card[i][0], card[j][0]);
	  swap (card[i][1], card[j][1]);
	}
      }
    }

    int ord[3];
    int t = 0;

    for (int i = 0; i < 5; i ++) {
      if (i == fir || i == sec)
	continue;
      
      ord[t] = i;
      t ++;
    }

    cout << "Problem " << x << ":";
    pCard (card[fir][0], card[fir][1]);
    pCard (card[sec][0], card[sec][1]);

    switch (diff) {
    case 1:
      pCard (card[ord[0]][0], card[ord[0]][1]);
      pCard (card[ord[1]][0], card[ord[1]][1]);
      pCard (card[ord[2]][0], card[ord[2]][1]);
      break;
    case 2:
      pCard (card[ord[1]][0], card[ord[1]][1]);
      pCard (card[ord[0]][0], card[ord[0]][1]);
      pCard (card[ord[2]][0], card[ord[2]][1]);
      break;
    case 3:
      pCard (card[ord[1]][0], card[ord[1]][1]);
      pCard (card[ord[2]][0], card[ord[2]][1]);
      pCard (card[ord[0]][0], card[ord[0]][1]);
      break;
    case 4:
      pCard (card[ord[0]][0], card[ord[0]][1]);
      pCard (card[ord[2]][0], card[ord[2]][1]);
      pCard (card[ord[1]][0], card[ord[1]][1]);
      break;
    case 5:
      pCard (card[ord[2]][0], card[ord[2]][1]);
      pCard (card[ord[0]][0], card[ord[0]][1]);
      pCard (card[ord[1]][0], card[ord[1]][1]);
      break;
    case 6:
      pCard (card[ord[2]][0], card[ord[2]][1]);
      pCard (card[ord[1]][0], card[ord[1]][1]);
      pCard (card[ord[0]][0], card[ord[0]][1]);
      break;
    }
    cout << endl;
  }

  return 0;
}
