//team 28
#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <vector>
#include <queue>
#include <algorithm>
#include <sstream>
using namespace std;
ifstream in ("h.in");
FILE * fin = fopen ("h.in", "r");
typedef long long lld;
#define cin in

int main () {
  string str;
  int N, M;
  int* target;
  int* row;
  int rule[8];

  for (int x = 1; ; x ++) {
    stringstream s;
    cin >> str;
    if (str == "END")
      return 0;
    
    cout << "LINE " << x;
    s << str;
    s >> M;
    cin >> str;

    N = str.size ();

    if (N % 2 == 0)
      cout << " NONE" << endl;
    else {
      bool bad = false;
      target = new int[N];
      row = new int[N];

      for (int i = 0; i < N && !bad; i ++) {
	if (str[i] == 'B') {
	  if (i == 0 || i == N - 1) {
	    cout << " NONE" << endl;
	    bad = true;
	  }

	  target[i] = 1;
	} else if (str[i] == 'W')
	  target[i] = 0;
	else {
	  cout << " NONE" << endl;
	  bad = true;
	}
      }
      /*
      for (int i = 0; i < N; i ++)
	cout << target[i];
      
      cout << endl;*/
      
      if (!bad) {
	bool found = false;
	
	for (int r = 1; r < 256; r ++) {
	  int t = r;
	  
	  for (int i = 0; i < 8; i ++) {
	    rule[i] = t % 2;
	    t /= 2;
	  }
	  
	  for (int i = 0; i < N; i ++)
	    row[i] = 0;
	  
	  row[N / 2] = 1;
	  
	  for (int i = 1; i <= M; i ++) {
	    int p = 0;
	    bool same = true;
	    
	    for (int j = 1; j < N - 1; j ++) {
	      if (row[j] != target[j])
		same = false;
	      
	      int s = rule[4 * p + 2 * row[j] + row[j + 1]];
	      p = row[j];
	      row[j] = s;
	    }
	    
	    if (same) {
	      cout << " (" << r << "," << i << ')';
	      found = true;
	      break;
	    }
	  }
	}
	
	if (!found)
	  cout << " NONE";
	cout << endl;
      }
      delete[] row;
      delete[] target;

    }
  }
  
  return 0;
}
